From 3577d451d7877ee00e765c2f93fd7e563ee45499 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 18 2020 04:48:13 +0000
Subject: [PATCH 160/2232] Fix blank first line if no headers emitted


---

diff --git a/gen/include.rs b/gen/include.rs
index a7657e4..b19a097 100644
--- a/gen/include.rs
+++ b/gen/include.rs
@@ -26,7 +26,7 @@ fn find_line(line: &str) -> Option<usize> {
     }
 }
 
-#[derive(Default)]
+#[derive(Default, PartialEq)]
 pub struct Includes {
     custom: Vec<String>,
     pub array: bool,
@@ -74,6 +74,9 @@ impl Display for Includes {
         if self.type_traits {
             writeln!(f, "#include <type_traits>")?;
         }
+        if *self != Self::default() {
+            writeln!(f)?;
+        }
         Ok(())
     }
 }
diff --git a/gen/out.rs b/gen/out.rs
index 124816f..2a5b17d 100644
--- a/gen/out.rs
+++ b/gen/out.rs
@@ -53,14 +53,18 @@ impl Write for OutFile {
     fn write_str(&mut self, s: &str) -> fmt::Result {
         if !s.is_empty() {
             if !self.blocks_pending.is_empty() {
-                self.content.push(b'\n');
+                if !self.content.is_empty() {
+                    self.content.push(b'\n');
+                }
                 for block in self.blocks_pending.drain(..) {
                     self.content.extend_from_slice(block.as_bytes());
                     self.content.extend_from_slice(b" {\n");
                 }
                 self.section_pending = false;
             } else if self.section_pending {
-                self.content.push(b'\n');
+                if !self.content.is_empty() {
+                    self.content.push(b'\n');
+                }
                 self.section_pending = false;
             }
             self.content.extend_from_slice(s.as_bytes());

